

function JKnamespace() {

	this.needIeStyleFix = $('<div style="{{test}}" />').get(0).getAttributeNode('style').value != '{{test}}';

	this.Template = function() {

		this.sections = [];

		this.html = '';

		this.partials = {};

		this.renderFnCode = '';

		this.dls = '{{';
		this.dle = '}}';

	};

	this.Template.prototype.addSection = function (type, path, content, dls, dle) {

		// delimiters
		dls = dls || '{{';
		dle = dle || '}}';

		var section = {
			content: content,
			path: path.replace(/^\.$/, '*'),
			inverted: (type == '^'),
			tmpl: new JK.Template(),
			dls: dls,
			dle: dle,
		};

		section.tmpl.partials = this.partials;
		section.tmpl.dls = dls;
		section.tmpl.dle = dle;
		section.tmpl.parse(content, dls, dle);

		this.sections.push(section);

	};

	/**
	 * @param {String}		s			searched string
	 * @param {String}		dls			start delimiter
	 * @param {String}		dle			end delimiter
	 * @param {Function}	callback	function(type, path, content, inNode, inAttr)
	 */
	this.Template.prototype.sectionReplace = function(s, dls, dle, callback) {

		var reFirst = new RegExp(dls + '([#^])[\\s]*([\\S]+?)[\\s]*' + dle);
		var reNext  = new RegExp(dls + '([#^/])[\\s]*([\\S]+?)[\\s]*' + dle);

		function findNextTag(s, tag, stack) {

			//var r = s.match(/{{([#^/])[\s]*([^}\s]+)[\s]*}}/);
			var r = s.match(reNext);
			// r[0] = match
			// r[1] = type
			// r[2] = tag
			// r.index = position
			if (r) {
				switch (r[1]) {
				case '/':
					if (r[2] != stack.pop()) {
						throw 'mustache parse error';
					}
					break;

				default:
					stack.push(r[2]);
					break;
				}
			}

			return r;

		}

		var inNode = false;
		var inAttr = false;
		var inNodeName = false;
		var searchpos = 0;
		while (true) {

			// search opening tag
			//var tag = s.match(/{{([#^])[\s]*([^}\s]+)[\s]*}}/);
			var tag = s.match(reFirst);
			// tag[0] = match
			// tag[1] = type
			// tag[2] = path
			// tag.index = position

			if (tag) {

				var type = tag[1];
				var path = tag[2];

				var stack = [];
				var content = '';
				stack.push(path);

				var r, end;
				var start = tag.index + tag[0].length;
				var run = start;
				do {

					r = findNextTag(s.substr(run), tag, stack);
					if (!r) break;
					if (!r[0]) break;
					end = run + r.index;
					run += r.index + r[0].length;

				} while (stack.length > 0);

				if (stack.length === 0) {
					// test, if section starts in an attribute value
					var i = searchpos;
					var char = '';
					while (i < tag.index) {
						char = s[i];
						if (!inNode) {
							if (char == '<') {
								inNode = true;
								inNodeName = true;
								inAttr = false;
							}
						} else {
							if ( inNodeName ) {
								if (char.match(/\s/)) {
									// whitespace => node name ended
									inNodeName = false;
								} else if (char.match(/[^a-zA-Z1-6]/)) {
									// perhaps we are not in a node def
									inNode = false;
									inNodeName = false;
									inAttr = false;
								}
							} else if ( !inAttr && (char == '>')) {
								inNode = false;
								inNodeName = false;
								inAttr = false;
							} else {
								if (char == '"') {
									inAttr = !inAttr;
								}
							}
						}
						i++;
					}

					inNode = inNode && !inNodeName;
					content = s.substring(start, end);
					var insert = callback(type, path, content, inNode, inAttr) || "";
					s = s.slice(0, tag.index) + insert + s.slice(tag.index + run - tag.index);
					searchpos = tag.index + insert.length;
				} else {
					break;
				}

			} else {
				break;
			}

		}

		return s;

	};

	this.Template.prototype.attributeSectionReplace = function( s ) {

		var self = this;
		return s.replace(/(<[^/ >]+)([^>]+)>/g, function(match, open, attributes) {

			var s1 = attributes.replace(/(\S+\s*=\s*")([^"]+)/g, function(match, attr, value) {

				if ( value.match(/^\|\|\d+\|\|$/) ) {
					// single section
					return attr + value;
				} else if ( value.match(/^{{[^}]+}}$/) ) {
					// single variable
					return attr + value;
				} else if (
						value.match(/\|\|\d+\|\|/) ||
						value.match(/{{[^}]+}}/)
				) {
					// turn into section
					var section = {
						path: '',
						inverted: false,
						tmpl: new JK.Template(),
						dls: '{{',
						dle: '}}',
					};

					section.tmpl.partials = self.partials;
					section.tmpl.dls = section.dls;
					section.tmpl.dle = section.dle;
					section.tmpl.html = value.replace(/\|\|(\d+)\|\|/g, function(match, sectionNr) {
						var sec = self.sections[sectionNr];
						section.tmpl.sections.push( sec );
						return '<jks jks="' + (section.tmpl.sections.length - 1) + '" />';
					});

					self.sections.push(section);

					return attr + '||' + (self.sections.length - 1) + '||';
				} else {
					// standard attribute value
					return attr + value;
				}
			});

			return open + s1 + '>';
		});

	};

	this.Template.prototype.setupRegExp = function(dls, dle) {

		function tag(type) {
			return dls + type + '[\\s]*([\\S]+?)[\\s]*' + dle;
		}
		function whTag(type) {
			var dle0 = (dle[0] == '\\') ? dle[1] : dle[0];
			return dls + type + '[^' +dle0+ ']+' + dle;
		}

		var re = {};

		// template variable
		re.varOnly = new RegExp( tag('(&?)'), 'g');
		// comments
		// /{{![^}]+}}/g
		re.comments = new RegExp( whTag('!'), 'g' );
		// partials {{>...}}
		// /^(.*?){{>[\s]*([^}\s]+?)[\s]*}}/gm
		re.partials = new RegExp( '^(.*?)' + tag('>'), 'gm' );
		// delimiters
		// /{{=[\s]*([\S]+)[\s]+([\S]+)[\s]*=}}/
		re.delimiters = new RegExp( dls + '=[\\s]*([\\S]+)[\\s]+([\\S]+)[\\s]*=' + dle );

		//if (window.mustacheTests) {

			/* whitespace control */
			// standalone section open without previous line
			// /^[\t ]*({{[#^][^}]+}})[\t ]*\r?\n/
			re.whSectionOpenStart = new RegExp('^[\\t ]*(' + whTag('[#^]') + ')[\\t ]*\\r?\\n');
			// standalone section open
			// /\r?\n[\t ]*({{[#^][^}]+}})[\t ]*(\r?\n)/g
			re.whSectionOpenMiddle = new RegExp('\\r?\\n[\\t ]*(' + whTag('[#^]') + ')[\\t ]*(\\r?\\n)', 'g');

			// standalone lines section close
			// /(\r?\n)[\t ]*({{\/[^}]+}})[\t ]*\r?\n/g
			re.whSectionCloseMiddle = new RegExp('(\\r?\\n)[\\t ]*(' + whTag('\\/') + ')[\\t ]*\\r?\\n', 'g');
			// standalone section close lines string end
			// /(\r?\n)[\t ]*({{\/[^}]+}})[\t ]*$/
			re.whSectionCloseEnd = new RegExp('(\\r?\\n)[\\t ]*(' + whTag('\\/') + ')[\\t ]*$');

			// partial standalone without previous line
			// /^([\t ]*{{>[^}]+}})[\t ]*\r?\n/
			re.whPartialStart = new RegExp('^([\\t ]*' + whTag('>') + ')[\\t ]*\\r?\\n');
			// standalone partial
			// /(\r?\n[\t ]*{{>[^}]+}})[\t ]*\r?\n/g
			re.whPartialMiddle = new RegExp('(\\r?\\n[\t ]*' + whTag('>') + ')[\\t ]*\\r?\\n', 'g');
			// standalone partial lines string end
			// /(\r?\n[\t ]*{{>[^}]+}})[\t ]*$/
			re.whPartialEnd = new RegExp('(\\r?\n[\\t ]*' + whTag('>') + ')[\\t ]*$');

			// standalone comment lines
			// string start
			// /^[\t ]*({{![^}]+}})[\t ]*\r?\n/
			re.whCommentStart = new RegExp('^[\\t ]*(' + whTag('!') + ')[\\t ]*\\r?\\n');
			// middle
			// /(\r?\n)[\t ]*({{![^}]+}})[\t ]*\r?\n/g
			re.whCommentMiddle = new RegExp('(\\r?\\n)[\\t ]*(' + whTag('!') + ')[\\t ]*\\r?\\n', 'g');
			// end
			// /[\t ]*({{![^}]+}})[\t ]*$/
			re.whCommentEnd = new RegExp('[\\t ]*(' + whTag('!') + ')[\\t ]*$');

			// standalone delimiter without previous line
			// /^[\t ]*({{=[^=]+=}})[\t ]*(\r?\n)/
			re.whDelimiterStart = new RegExp('^[\\t ]*(' + dls + '=[^=]+=' + dle + ')[\\t ]*\\r?\\n');
			// standalone delimiter
			// /^({{=[^=]+=}})[\t ]*(\r?\n)/
			re.whDelimiter = new RegExp('^(' + dls + '=[^=]+=' + dle + ')[\\t ]*\\r?\\n');

		//}

		return re;

	};

	/**
	 * @param {String}	str
	 */
	this.Template.prototype.parse = function(str) {

		// delimiters
		var dls = this.dls || '{{';
		var dle = this.dle || '}}';

		var self = this;

		function setDelimiter(re, toDls, toDle) {
			var flags = '';
			if (re.global) flags += 'g';
			if (re.ignoreCase) flags += 'i';
			if (re.multiline) flags += 'm';
			return new RegExp( re.source.replace('{{', toDls).replace('}}', toDle), flags );
		}

		function replacePartial(match, indent, partial) {
			if ( self.partials[partial]) {
				var pindent = '';
				if (indent.search(/^[\s]+$/) >= 0) {
					pindent = indent;
				}
				return indent + '<jkp jkp="' + partial + '" jkp-indent="' + pindent + '" />';
			}
			return indent;
		}

		function replaceSection(type, path, content, inNode, inAttr) {
			if (content.length === 0) return '';
			self.addSection(type, path, content, dls, dle);
			if (inNode) {
				// if section is in a node or attribute, we need a different replacement to make $.parseHTML work
				return "||" + (self.sections.length - 1) + "||";
			} else {
				return '<jks jks="' + (self.sections.length - 1) + '" />';
			}
		}

		function replaceSectionNode(match, tag, attrs, nr) {
			return '<' + tag + ' jks="' + nr + '"' + attrs + ' />';
		}

		if ( !this.html ) {

			var s;
			this.html = '';

			var re = this.setupRegExp(dls, dle);

			str = str.replace(re.whDelimiterStart, '$1');

			while (true) {

				if (!str) break;
				var m = str.match(re.delimiters);
				if (!m) {
					s = str;
					str = '';
				} else if (m.index > 0) {
					s = str.substring(0, m.index);
					str = str.substring(m.index);
					if ( s.match(/\r?\n[\t ]*$/) ) {
						s = s.replace(/[\t ]*$/, '');
						str = str.replace(re.whDelimiter, '$1');
					}
				} else {
					dls = JK.escapeDelimiter(m[1]);
					dle = JK.escapeDelimiter(m[2]);
					re = this.setupRegExp(dls, dle);

					this.html += m[0];
					str = str.substring(m[0].length);
					continue;
				}

				// Standalone lines should be removed from the template.

				s = s.replace(re.whSectionOpenStart, '$1');
				s = s.replace(re.whSectionOpenMiddle, '$1$2');

				s = s.replace(re.whSectionCloseMiddle, '$1$2');
				s = s.replace(re.whSectionCloseEnd, '$1$2');

				s = s.replace(re.whPartialStart, '$1');
				s = s.replace(re.whPartialMiddle, '$1');
				s = s.replace(re.whPartialEnd, '$1');

				s = s.replace(re.whCommentStart, '$1');
				s = s.replace(re.whCommentMiddle, '$1$2');
				s = s.replace(re.whCommentEnd, '$1');

				/* replace template comments */

				// replace {{!...}}
				s = s.replace(re.comments, '');

				// fix IE style problem
				if ( JK.needIeStyleFix ) {
					s = s.replace(/style(=["'][^"']*{{[^"']*["'])/g, 'style-ie$1');
				}

				/* replace template partials */

				// replace {{>...}}
				s = s.replace(re.partials, replacePartial);

				/* replace template sections */
				s = this.sectionReplace(s, dls, dle, replaceSection);

				// replace <node ...><jks jks="n" /></node>
				// to      <node ... jks="n" />
				s = s.replace(/<([^ >]+)([^>]*)>[\s]*<jks jks="([^"]+)" \/>[\s]*<\/\1>/g, replaceSectionNode);

				s = this.attributeSectionReplace( s );

				this.html += s;

			}

		}

		return this.html;

	};

	/**
	 * @returns {jQueryObject}
	 */
	this.Template.prototype.render = function(data) {

		var renderInstance = new JK.RenderInstance( this, data );

		return renderInstance.render( data );

	};

	/**
	 * Render Instance
	 */

	/**
	 * @param {JKnamespace.Template} template
	 */
	this.RenderInstance = function( template, data, parent ) {

		this.template = template;

		this.data = data;

		this.parent = parent;

		this.modelCallbacks = [];

		this.changeCounter = JK.model({val: 0});
		//this.changeCounter.extendProp('val', 0);

		this.dls = template.dls || '{{';
		this.dle = template.dle || '}}';

		if (parent) {
			this.changeCounter.on('change', 'val', function() {
				parent.changeCounter.val++;
			});
		}

	};

	/**
	 * @returns {jQueryObject}
	 */
	this.RenderInstance.prototype.render = function() {

		var template = this.template;
		if ( template.cNode ) {

			var cNode = template.cNode.cloneNode(true);

			this.renderTree( cNode, template.cTree );

			cNode.childNodes[0].ddt	= this;
			return $(cNode.childNodes);

		} else if ( template.renderFn ) {

			// compile1
			return template.renderFn.call(this);

		} else {

			// uncompiled
			var $tmpl = $('<div/>').append( $.parseHTML(this.template.html) );

			if ( $tmpl.contents().length === 0 ) return this.template.html;

			// replace variables and sections in attributes
			this.renderNodes( $tmpl.get(0).childNodes, this.dls, this.dle );

			$tmpl = $tmpl.contents();
			$tmpl.get(0).ddt	= this;
			return $tmpl;

		}

	};

	this.RenderInstance.prototype.getValue = function(path) {

		if ( (this.data instanceof JKobject) && (this.data[path] !== undefined) ) {
			var value = this.data[path];
			if (typeof value == 'function') {
				value = value.call(this.data);
			}
			return {
				data: this.data,
				value: value,
				path: path,
				fnThisVar: this.data,
			};
		} else {
			var result = this._getValue(path);

			if (result.value === undefined) {
				result.value = '';
				result.data = this.data;
				result.fnThisVar = this.data;
			}

			return result;

		}

	};

	this.RenderInstance.prototype._getValue = function(path, fnThisVar) {

		var result = {
			data: this.data,
			value: this.data,
			path: path,
			fnThisVar: fnThisVar || this.data,
		};

		if (result.value !== undefined) {
			var key;
			var keys = path.split('.');
			while (keys.length > 0) {
				key = keys.shift();
				if (key != '*') {

					// comment this out, to be compatible with Mustache.js
					// uncomment this, to be compatible to Hogan.js
					// see test "scope in functions and lambdas"
					if (!fnThisVar) result.fnThisVar = result.value;

					result.value = result.value[key];
					if (typeof result.value == 'undefined') {
						// path element not found
						if (this.parent) {
							result = this.parent._getValue(path, result.fnThisVar);
						}
						break;
					} else if (typeof result.value == 'function') {
						result.value = result.value.call(result.fnThisVar);
					}
					if ( !(result.data instanceof JKobject)) {
						result.data = result.value;
						var p = result.path.indexOf('.');
						if (p < 0) {
							result.path = '*';
						} else {
							result.path = result.path.substring(p + 1);
						}
					}
				}
				if (keys.length === 0) {
					// all path elements exist
					break;
				} else if ( !JK.isObject(result.value) && !JK.isArray(result.value) ) {
					result.value = undefined;
					break;
				}
				fnThisVar = null;
			}
		}

		return result;

	};

	function onSectionAdd(e, val, obj, prop, oldVal, parentRI, tmpl, $tag, items) {
		parentRI.changeCounter.val++;

		var ri = new JK.RenderInstance( tmpl, val, parentRI);
		var $tmpl = ri.render();
		if (prop < items.length) {
			// insert
			items.splice( prop, 0, $tmpl.insertBefore(items[prop].first()) );
		} else {
			// append
			$tag.append( $tmpl );
			items.push( $tmpl );
		}
	}

	function onSectionChange(e, val, obj, prop, oldVal, parentRI, tmpl, $tag, items) {
		var ri;
		parentRI.changeCounter.val++;
		if ( JK.isEmpty(val) ) {
			if ( !JK.isEmpty( oldVal ) ) {
				JK.removeTemplate( $tag, false );
				$tag.empty();
			}
		} else if ( JK.isArray(val) ) {
			// list section
			for(var i = 0, len = val.length; i < len; i++) {
				ri = new JK.RenderInstance( tmpl, val[i], parentRI);
				items.push( ri.render().appendTo($tag) );
			}
		} else {
			ri = new JK.RenderInstance( tmpl, val, parentRI);
			$tag.html( ri.render() );
		}
	}

	function onSectionDelete(e, val, obj, prop, oldVal, changeCounter, items) {
		changeCounter.val++;
		JK.removeTemplate( items[prop] );
		items.splice(prop, 1);
	}

	function sectionSort(a, b) {
		return (a.jkIndex > b.jkIndex) ? 1 : (a.jkIndex == b.jkIndex) ? 0 : -1;
	}

	function onSectionSort(e, val, obj, prop, oldVal, changeCounter, $tag, items) {
		var i, len;
		changeCounter.val++;
		for (i = 0, len = val.length; i < len; i++) {
			items[i].jkIndex = val[i];
		}

		items.sort( sectionSort );
		for (i = 0, len = items.length; i < len; i++) {
			items[i].appendTo($tag);
		}
	}

	function onSectionDetach(e, val, obj, prop, oldVal, changeCounter, $tag, items) {
		// clear list, if events are inhibited
		if (!val) {
			for (i = 0, len = items.length; i < len; i++) {
				JK.removeTemplate( items[i] );
			}
			items.length = 0;
		}
		$tag.detachTemp();
	}

	function onSectionAttach(e, val, obj, prop, oldVal, parentRi, tmpl, $tag, items) {
		parentRi.changeCounter.val++;

		// render list, if events were inhibited
		if (!val) {
			for(var i = 0, len = obj.length; i < len; i++) {
				var ri = new JK.RenderInstance( tmpl, obj[i], parentRi);
				var $tmpl = ri.render();
				items.push( $tmpl );
			}
			$tag.append( items );
		}
		$tag.reattach();
	}

	this.RenderInstance.prototype.renderSection = function( node, section ) {

		var $tag = $(node);
		var items = [];

		var value = this.getValue( section.path );

		// add data binding
		if (value.data instanceof JKobject) {

			var addPath = (value.path == '*') ? '*' : value.path + '.*';
			this.modelCallbacks.push({
				cb: value.data.on( 'add', addPath, onSectionAdd, this, section.tmpl, $tag, items ),
				data: value.data
			});

			if (value.path != '*') {
				this.modelCallbacks.push({
					cb: value.data.on( 'change', value.path, onSectionChange, this, section.tmpl, $tag, items ),
					data: value.data
				});
			}

			// add delete callback
			this.modelCallbacks.push({
				cb: value.data.on( 'del', (value.path == '*') ? '*' : value.path + '.*', onSectionDelete, this.changeCounter, items ),
				data: value.data
			});

			// add sort callback
			var vpath = value.path.replace(/^\*/, '__this');
			this.modelCallbacks.push({
				cb: value.data.on( 'sort', vpath, onSectionSort, this.changeCounter, $tag, items ),
				data: value.data
			});

			// detach callback
			this.modelCallbacks.push({
				cb: value.data.on( 'detach', vpath, onSectionDetach, this.changeCounter, $tag, items ),
				data: value.data
			});

			// attach callback
			this.modelCallbacks.push({
				cb: value.data.on( 'attach', vpath, onSectionAttach, this, section.tmpl, $tag, items ),
				data: value.data
			});

		}

		var ri;
		if ( JK.isArray(value.value) ) {
			// list section
			var i = 0,
				val = value.value,
				len = val.length;
			for(; i < len; i++) {
				ri = new JK.RenderInstance( section.tmpl, val[i], this);
				var $tmpl = ri.render();
				items.push( $tmpl );
			}
			$tag.append( items );

		} else if ( !JK.isEmpty(value.value) ) {

			if (JK.isObject( value.value ) ) {
				ri = new JK.RenderInstance( section.tmpl, value.value, this);
				$tag.append( ri.render() );
			} else if (typeof value.value == 'function') {
				// lambda section
				var content = value.value.call( value.fnThisVar, section.tmpl.html, function(s) { return s; } );
				var lTmpl = new JK.Template();
				lTmpl.partials = this.template.partials;
				lTmpl.dle = section.dle;
				lTmpl.dls = section.dls;
				lTmpl.parse(content);
				ri = new JK.RenderInstance( lTmpl, value.data, this);
				$tag.append( ri.render() );
			} else {
				// value is a primitive => render with parent object as data
				ri = new JK.RenderInstance( section.tmpl, value.data, this);
				$tag.append( ri.render() );
			}
		}

	};

	function onSectionInvChange(e, val, obj, prop, oldVal, parentRI, tmpl, $tag) {
		parentRI.changeCounter.val++;
		if ( JK.isEmpty(val) ) {
			var ri = new JK.RenderInstance( tmpl, obj, parentRI);
			$tag.append( ri.render() );
		} else if ( JK.isEmpty( oldVal ) ) {
			JK.removeTemplate( $tag, false );
			$tag.empty();
		}
	}

	this.RenderInstance.prototype.renderInvertedSection = function( node, section ) {

		var $tag = $(node);

		var value = this.getValue( section.path );

		// add data binding
		if (value.data instanceof JKobject) {

			// add length callback for inverted sections
			this.modelCallbacks.push({
				cb: value.data.on( 'change', value.path, onSectionInvChange, this, section.tmpl, $tag ),
				data: value.data
			});

		}

		var ri;
		// boolean  section
		// (value not empty) XOR section.inverted
		if ( JK.isEmpty(value.value) ) {
			if (JK.isObject( value.value ) ) {
				ri = new JK.RenderInstance( section.tmpl, value.value, this);
				$tag.append( ri.render() );
			} else if (typeof value.value == 'function') {
				// lambda section
				var content = value.value.call( value.fnThisVar, section.tmpl.html, function(s) { return s; } );
				var lTmpl = new JK.Template();
				lTmpl.partials = this.template.partials;
				lTmpl.dle = section.dle;
				lTmpl.dls = section.dls;
				lTmpl.parse(content);
				ri = new JK.RenderInstance( lTmpl, value.data, this);
				$tag.append( ri.render() );
			} else {
				// value is a primitive => render with parent object as data
				ri = new JK.RenderInstance( section.tmpl, value.data, this);
				$tag.append( ri.render() );
			}
		}

	};

	this.RenderInstance.prototype.renderPartial = function( node, partial, indent ) {

		var $tag = $(node);

		var ptmpl = new JK.Template();
		ptmpl.partials = this.template.partials;
		ptmpl.parse(partial);

		ptmpl.html = ptmpl.html.replace(/\n(?=.)/g, '\n' + indent );
		if (ptmpl.compile) {
			ptmpl.compile();
		}

		var ri = new JK.RenderInstance( ptmpl, this.data, this);
		var $ptmpl = ri.render();
		$tag.append($ptmpl);

	};

	this.isSpecialAttribute = function( node, attribute ) {

		var result = false;
		switch (attribute.nodeName) {
			case 'value':
				/**
				 * special attribute "value" of select-element
				 * should set/change selected option
				 */
				if (node.nodeName.toUpperCase() == 'SELECT') {
					result = true;
				}
				break;

			case 'value-bd':
				/**
				 * special attribute "value-bd" of select/input-element
				 * should set/change selected option
				 */
				if (['SELECT', 'INPUT'].indexOf(node.nodeName.toUpperCase()) >= 0 ) {
					result = true;
				}
				break;

			case 'checked':
			case 'checked-bd':
				/**
				 * special attribute "checked", "checked-bd" (2way) of input-element
				 * should set/change selected option
				 */
				if (node.nodeName.toUpperCase() == 'INPUT') {
					result = true;
				}
				break;

			case 'style-ie':
				// IE style attribute fix
				// create new style attribute
				result = true;
				break;

		}

		return result;

	};

	this.RenderInstance.prototype.handleSpecialAttribute = function( node, attribute, value, obj, prop ) {

		switch (attribute.nodeName) {
			case 'value':
				/**
				 * special attribute "value" of select-element
				 * should set/change selected option
				 */
				if (node.nodeName.toUpperCase() == 'SELECT') {
					$(node).val( value );
				}
				break;

			case 'checked':
				/**
				 * special attribute "checked" of input-element
				 * should set/change selected option
				 */
				if (node.nodeName.toUpperCase() == 'INPUT') {
					node.checked = !!value;
				}
				break;

			case 'value-bd':
				/**
				 * special attribute "value-bd" of select-element
				 * should update data on change
				 */
				if (node.nodeName.toUpperCase() == 'SELECT') {
					$(node).val( value );
					if ( !node.bidirObj && obj) {
						// add handler for bi-directional databinding
						node.bidirObj = obj;
						node.bidirProp = prop;
						$(node).change( function() {
							var val = $(this).val();
							if (typeof this.bidirObj[this.bidirProp] == 'number') {
								val = parseInt(val);
							}
							this.bidirObj[this.bidirProp] = val;
						});
					}
				} else if (node.nodeName.toUpperCase() == 'INPUT') {
					$(node).val( value );
					if ( !node.bidirObj && obj) {
						// add handler for bi-directional databinding
						node.bidirObj = obj;
						node.bidirProp = prop;
						$(node).keyup( function() {
							var val = $(this).val();
							if (typeof this.bidirObj[this.bidirProp] == 'number') {
								val = parseInt(val);
							}
							this.bidirObj[this.bidirProp] = val;
						});
					}
				}
				break;

			case 'checked-bd':
				/**
				 * special attribute "checked-bd" of input-element
				 * should update data on click
				 */
				if (node.nodeName.toUpperCase() == 'INPUT') {
					node.checked = !!value;
					if ( !node.bidirObj && obj) {
						node.bidirObj = obj;
						node.bidirProp = prop;
						node.addEventListener('click', function() {
							this.bidirObj[this.bidirProp] = this.checked;
						} , false);
					}
				}
				break;

			case 'style-ie':
				// IE style attribute fix
				// create new style attribute
				var styleAttr = document.createAttribute('style');
				styleAttr.value = value;
				node.setAttributeNode( styleAttr );
				break;

		}

	};

	function onNodeVariableChange(e, val, obj, prop, oldVal, changeCounter, node) {
		changeCounter.val++;
		$(node).html( val );
	}

	/**
	 * replace a template variable of an element node
	 *
	 * @param {Node} node
	 */
	this.RenderInstance.prototype.renderNodeVariable = function(node, path, dls ) {

		var value = this.getValue( path );

		if ( typeof value.value == 'function' ) {
			// lambda
			var content = value.value.call(value.fnThisVar);
			var re = new RegExp(dls);
			if (typeof content == 'string' && content.match(re)) {
				var lTmpl = new JK.Template();
				lTmpl.partials = this.template.partials;
				lTmpl.parse(content);

				if (!node.hiddenTemplates) {
					node.hiddenTemplates = [];
				}

				var ri = new JK.RenderInstance( lTmpl, value.data, this);
				var $contents = [ ri.render() ];
				node.hiddenTemplates.push( $contents );

				$(node).html( $contents[0] );
			} else {
				$(node).html( content );
			}

		} else {
			$(node).html( value.value );
		}

		// add late data binding
		if (value.data instanceof JKobject) {
			this.modelCallbacks.push({
				cb: value.data.on( 'change'	, value.path, onNodeVariableChange, this.changeCounter, node ),
				data: value.data
			});
		}

	};

	function onTextVariableChange(e, val, obj, prop, oldVal, changeCounter, node) {
		changeCounter.val++;
		node.nodeValue = val;
	}

	/**
	 * replace a template variable of a text node
	 *
	 * @param {Node} node
	 */
	this.RenderInstance.prototype.renderTextVariable = function(node, path, dls ) {

		var value = this.getValue( path );

		if ( typeof value.value == 'function' ) {
			// lambda
			var content = value.value.call(value.fnThisVar);
			var re = new RegExp(dls);
			if (typeof content == 'string' && content.match(re)) {
				var lTmpl = new JK.Template();
				lTmpl.partials = this.template.partials;
				lTmpl.parse(content);

				if (!node.hiddenTemplates) {
					node.hiddenTemplates = [];
				}

				var ri = new JK.RenderInstance( lTmpl, value.data, this);
				var $contents = [ ri.render() ];
				node.hiddenTemplates.push( $contents );

				node.nodeValue = $contents[0].text();
			} else {
				node.nodeValue = content;
			}

		} else {
			node.nodeValue = value.value;
		}

		// add late data binding
		if (value.data instanceof JKobject) {
			this.modelCallbacks.push({
				cb: value.data.on( 'change'	, value.path, onTextVariableChange, this.changeCounter, node ),
				data: value.data
			});
		}

	};

	function onAttrVariableChange(e, val, obj, prop, oldVal, ri, node, attribute) {
		ri.changeCounter.val++;
		attribute.value = val;
	}

	/**
	 * replace a template variable of an attribute node
	 *
	 * @param {Node} node
	 */
	this.RenderInstance.prototype.renderAttrVariable = function(node, attribute, path, dls ) {

		var value = this.getValue( path.replace(/^\.$/, '*') );

		if ( typeof value.value == 'function' ) {
			// lambda
			var content = value.value.call(value.fnThisVar);
			var re = new RegExp(dls);
			if (typeof content == 'string' && content.match(re)) {
				var lTmpl = new JK.Template();
				lTmpl.partials = this.template.partials;
				lTmpl.parse(content);

				if (!node.hiddenTemplates) {
					node.hiddenTemplates = [];
				}

				var ri = new JK.RenderInstance( lTmpl, value.data, this);
				var $contents = [ ri.render() ];
				node.hiddenTemplates.push( $contents );

				attribute.value = $contents[0].text();
			} else {
				attribute.value = content;
			}

		} else {
			attribute.value = value.value;
		}

		// add late data binding
		if (value.data instanceof JKobject) {
			this.modelCallbacks.push({
				cb: value.data.on( 'change'	, value.path, onAttrVariableChange, this, node, attribute ),
				data: value.data
			});
		}

	};

	function onSpecialAttrVariableChange(e, val, obj, prop, oldVal, ri, node, attribute) {
		ri.changeCounter.val++;
		attribute.value = val;
		ri.handleSpecialAttribute( node, attribute, val, obj, prop );
	}

	/**
	 * replace a template variable of an attribute node
	 *
	 * @param {Node} node
	 */
	this.RenderInstance.prototype.renderSpecialAttrVariable = function(node, attribute, path, dls ) {

//		var self = this;
//
//		function setNodeValue( node, attribute, value ) {
//
//			//if (typeof value == 'number') {
//			//	value = value.toString();
//			//}
//
//			attribute.value = value;
//
//			// attribute node
//			self.handleSpecialAttribute( node, attribute, value );
//		}

		var value = this.getValue( path.replace(/^\.$/, '*') );

		if ( typeof value.value == 'function' ) {
			// lambda
			var content = value.value.call(value.fnThisVar);
			var re = new RegExp(dls);
			if (typeof content == 'string' && content.match(re)) {
				var lTmpl = new JK.Template();
				lTmpl.partials = this.template.partials;
				lTmpl.parse(content);

				if (!node.hiddenTemplates) {
					node.hiddenTemplates = [];
				}

				var ri = new JK.RenderInstance( lTmpl, value.data, this);
				var $contents = [ ri.render() ];
				node.hiddenTemplates.push( $contents );

				attribute.value = $contents[0].text();
				this.handleSpecialAttribute( node, attribute, attribute.value );
			} else {
				attribute.value = content;
				this.handleSpecialAttribute( node, attribute, content );
			}

		} else {
			attribute.value = value.value;
			// get object and property of value
			var obj = value.data;
			var prop = value.path;
			if ( prop.indexOf('.') >= 0 ) {
				var props = prop.split('.');
				while ( props.length > 1 ) {
					prop = props.shift();
					obj = obj[prop];
				}
				prop = props.shift();
			}
			this.handleSpecialAttribute( node, attribute, value.value, obj, prop );
		}

		// add late data binding
		if (value.data instanceof JKobject) {
			this.modelCallbacks.push({
				cb: value.data.on( 'change'	, value.path, onSpecialAttrVariableChange, this, node, attribute ),
				data: value.data
			});
		}

	};

	function onSectionAroundAttributesChange(e, val, obj, prop, oldVal, ctx) {
		ctx.ri.changeCounter.val++;
		for(var i = 0, len = ctx.$contents.length; i < len; i++) {
			JK.removeTemplate( ctx.$contents[i] );
		}
		ctx.$contents.length = 0;
		ctx.ri.renderSectionAroundAttributes(ctx.node, ctx.section, ctx.dls, ctx.dle, ctx.attributes, ctx.$contents);
	}

	this.RenderInstance.prototype.renderSectionAroundAttributes = function(node, section, dls, dle, attributes, $contents) {

		var i, len;

		var value = this.getValue( section.path.replace(/^\.$/, '*') );

		if (!attributes) {
			// inital call
			attributes = [];
			if (!node.hiddenTemplates) {
				node.hiddenTemplates = [];
			}
			$contents = [];
			node.hiddenTemplates.push( $contents );

			// add late data binding
			if (value.data instanceof JKobject) {

				var cbData = {
						ri: this,
						$contents: $contents,
						attributes: attributes,
						section: section,
						node: node,
						dls: dls,
						dle: dle,
				};

				this.modelCallbacks.push({
					cb: value.data.on( 'change'	, value.path, onSectionAroundAttributesChange, cbData ),
					data: value.data
				});
			}
		}

		var ri;
		if (
				!section.inverted &&
				JK.isArray( value.value )
		) {
			// list section
			for(i = 0, len = value.value.length; i < len; i++) {
				ri = new JK.RenderInstance( section.tmpl, value.value[i], this);
				ri.dls = section.dls;
				ri.dle = section.dle;
				$contents.push( ri.render() );
			}
		} else {
			// boolean true section
			// (value not empty) XOR section.inverted
			if ( JK.isEmpty(value.value) == section.inverted ) {
				if (value.value instanceof JKobject) {
					ri = new JK.RenderInstance( section.tmpl, value.value, this);
					ri.dls = section.dls;
					ri.dle = section.dle;
					$contents.push( ri.render() );
				} else if (typeof value.value == 'function') {
					// lambda section
					var scontent = value.value( value.fnThisVar, section.tmpl.html, function(s) { return s; } );
					var lTmpl = new JK.Template();
					lTmpl.partials = this.template.partials;
					lTmpl.parse(scontent, section.dls, section.dle);
					ri = new JK.RenderInstance( lTmpl, value.data, this);
					ri.dls = section.dls;
					ri.dle = section.dle;
					$contents.push( ri.render() );
				} else {
					// value is a primitive => render with parent object as data
					ri = new JK.RenderInstance( section.tmpl, value.data, this);
					ri.dls = section.dls;
					ri.dle = section.dle;
					$contents.push( ri.render() );
				}
			}
		}

		var content = '';
		for(i = 0, len = $contents.length; i < len; i++) {
			content += $contents[i].text();
		}
		var renderedAttribute,
		renderedAttributeNames = [],
		renderedAttributeValues = [],
		attributeName, attributeValue;
		// parse content
		var renderedAttributes = content.match(/[^=\s]+(\s*=\s*"[^"]+")?/g);
		if (renderedAttributes) {
			for(i = 0, len = renderedAttributes.length; i < len; i++) {
				renderedAttribute = renderedAttributes[i];
				if ( renderedAttribute ) {
					var m = renderedAttribute.match(/([^=\s]+)\s*=\s*"([^"]+)"/);
					if ( m ) {
						renderedAttributeNames.push(m[1]);
						renderedAttributeValues.push(m[2]);
					} else {
						renderedAttributeNames.push(renderedAttribute);
						renderedAttributeValues.push('');
					}
				}
			}
		}
		// remove disappeared attributes
		i = 0;
		len = attributes.length;
		while(i < len) {
			attributeName = attributes[i];
			if (!renderedAttributes || renderedAttributeNames.indexOf(attributeName) == -1) {
				switch (attributeName) {
					case 'checked'	: node.checked	= false; break;
					case 'selected'	: node.selected	= false; break;
					case 'required'	: node.required	= false; break;
					case 'disabled'	: node.disabled	= false; break;
					default:
						$(node).removeAttr( attributeName );
				}
				// remove attribute
				attributes.splice(i, 1);
				len--;
			} else {
				i++;
			}
		}
		// add new attributes or update attribute values
		for(i = 0, len = renderedAttributeNames.length; i < len; i++) {
			attributeName = renderedAttributeNames[i];
			attributeValue = renderedAttributeValues[i];
			switch (attributeName) {
				// handle special cases
				case 'checked'	: node.checked	= true; break;
				case 'selected'	: node.selected	= true; break;
				case 'required'	: node.required	= true; break;
				case 'disabled'	: node.disabled	= true; break;
				default:
					$(node).attr( attributeName, attributeValue);
			}
			if (attributes.indexOf(attributeName) == -1) {
				attributes.push(attributeName);
			}
		}

	};

	function onChangeCounterChange(e, val, obj, prop, oldVal, ri, node, attribute, $content) {
		var content = $content.text();
		attribute.nodeValue = content;
		ri.handleSpecialAttribute( node, attribute, content );
	}

	this.RenderInstance.prototype.renderAttributeSection = function(node, attribute, section) {

		var $content;
		var ri = new JK.RenderInstance( section.tmpl, this.data, this);
		if (section.path) {
			var sNode = document.createElement('div');
			ri.renderSection( sNode, section);
			sNode.ddt = ri;
			$content = $(sNode);
		} else {
			$content = ri.render();
		}
		var content = $content.text();
		attribute.nodeValue = content;
		this.handleSpecialAttribute( node, attribute, content );

		if (!node.hiddenTemplates) {
			node.hiddenTemplates = [];
		}
		node.hiddenTemplates.push( [ $content ] );

		ri.changeCounter.on('change', 'val', onChangeCounterChange, this, node, attribute, $content);

	};

	this.RenderInstance.prototype.renderElementNode = function(node, dls, dle) {

		var re = new RegExp( '^' + dls + '[\\s]*(.+?)[\\s]*' + dle + '$' );

		// loop through all attributes
		var sectionNr,
			section,
			partialName = '',
			indent = '';
		for( var i = 0; i < node.attributes.length; i++ ) {
			var attribute = node.attributes[i];

			if (attribute.nodeName == 'jks') {
				// section node

				sectionNr = parseInt( attribute.nodeValue );
				section = this.template.sections[sectionNr];
				if (section.inverted) {
					this.renderInvertedSection( node, section );
				} else {
					this.renderSection( node, section );
				}
				node.removeAttribute(attribute.nodeName);
				i--;

			} else if (attribute.nodeName == 'jkp') {

				partialName = attribute.nodeValue;
				node.removeAttribute(attribute.nodeName);
				i--;

			} else if (attribute.nodeName == 'jkp-indent') {

				indent = attribute.nodeValue;
				node.removeAttribute(attribute.nodeName);
				i--;

			} else if (attribute.nodeName.match(/^\|\|(\d+)\|\|$/)) {
				// section around attributes

				sectionNr = parseInt( attribute.nodeName.replace(/^\|\|(\d+)\|\|$/, '$1') );
				this.renderSectionAroundAttributes( node, this.template.sections[sectionNr], dls, dle );

				node.removeAttribute(attribute.nodeName);
				i--;

			} else {

				var match = attribute.nodeValue.match( re );
				if ( match ) {

					// single variable in attribute value
					var path = match[1];
					if ( JK.isSpecialAttribute( node, attribute )) {
						this.renderSpecialAttrVariable( node, attribute, path.replace(/^\.$/, '*'), dls );
					} else {
						this.renderAttrVariable( node, attribute, path.replace(/^\.$/, '*'), dls );
					}

				} else {

					match = attribute.nodeValue.match( /^\|\|(\d+)\|\|$/ );
					if ( match ) {

						// single section in attribute value
						sectionNr = parseInt( match[1] );
						section = this.template.sections[sectionNr];
						this.renderAttributeSection( node, attribute, section );

					}
				}
			}

		}

		if ( partialName ) {

			//					node, partial
			this.renderPartial( node, this.template.partials[partialName], indent );

		}

	};

	this.RenderInstance.prototype.renderNodes = function(nodes, dls, dle) {

		function setupRegExp(dls, dle) {
			return new RegExp( dls + '([{=&]?)[\\s]*(.+?)[\\s]*' + dle + '[}]?' );
		}

		var re = setupRegExp(dls, dle);

		for (var i = 0; i < nodes.length; ++i) {
			var node = nodes[i];

			if (node.nodeType == 1) {
				// ELEMENT_NODE

				this.renderElementNode( node, dls, dle );

				// recursion
				if ( !node.nodeName.match(/^jk[ps]/i) ) {
					this.renderNodes(node.childNodes, dls, dle);
				}

			} else if (node.nodeType == 3) {
				// text node

				// search variables in node text
				var tmplVar = node.nodeValue.match(re);
				if (tmplVar) {
					var match = tmplVar[0];
					var type = tmplVar[1];
					var path = tmplVar[2];
					var position = tmplVar.index;

					if (type == '=') {
						// delimiter change
						var reDelimiters = new RegExp( '=[\\s]*([\\S]+)[\\s]+([\\S]+)[\\s]*=' );
						var deMatch = match.match(reDelimiters);
						if ( deMatch ) {
							dls = JK.escapeDelimiter(deMatch[1]);
							dle = JK.escapeDelimiter(deMatch[2]);
							re = setupRegExp(dls, dle);
						}
						var str = node.nodeValue;
						node.nodeValue = (position) ? str.substring(0, position) : '';
						node.nodeValue += str.substring(position + match.length);
						i--;
					} else {

						var escape = (type != '&') && (type != '{');

						// split the node into three parts (before var, var, behind var)
						var tmplVarNode;
						var onlyContent = nodes.length == 1;
						if (position > 0) {
							onlyContent = false;
							tmplVarNode = node.splitText(position);
							// skip tmplVarNode
							i++;
						} else {
							tmplVarNode = node;
						}
						if (match.length < tmplVarNode.nodeValue.length) {
							onlyContent = false;
							tmplVarNode.splitText(match.length);
						}

						if (!escape) {
							if (onlyContent) {
								tmplVarNode = node.parentNode;
								this.renderNodeVariable(tmplVarNode, path.replace(/^\.$/, '*'), dls);
							} else {
								var newNode = document.createElement('jkt');
								node.parentNode.replaceChild(newNode, tmplVarNode);
								tmplVarNode = newNode;
								this.renderNodeVariable(tmplVarNode, path.replace(/^\.$/, '*'), dls);
							}
						} else {
							this.renderTextVariable(tmplVarNode, path.replace(/^\.$/, '*'), dls);
						}

						if (!escape && onlyContent) {
							break;
						}

					}

				}

			}

		}

	};

	this.inherit = function(child, parent) {

	    function F() { this.constructor = child; }
	    F.prototype = child._super = parent.prototype;
	    child.prototype = new F();
	    child.mixin = function() {
			child.prototype.mixin.apply(child.prototype, arguments);
		};

	};

	/**
	 * create a model
	 *
	 * @return {JKobject}
	 */
	this.model = function( obj ) {

		if (
				( typeof obj != 'object' ) ||
				( obj === null ) ||
				( obj instanceof Date ) ||
				( obj instanceof JKobject)
		) {
			return obj;
		} else if ( obj.JKobject ) {
			// circular creation
			return obj.JKobject;
		} else {

			var m;

			if (Object.prototype.toString.call( obj ) === '[object Array]') {
				m = new JKarray();
			} else {
				m = new JKobject();
			}

			// prevent circular creation
			Object.defineProperty(obj, 'JKobject', {
				enumerable: false,
				configurable: true,
				value: m
			});
			m.init(obj);
			delete obj.JKobject;

			return m;
		}

	};

	this.isArray = function(obj) {
		return	(obj instanceof JKarray) ||
				(Object.prototype.toString.call( obj ) === '[object Array]');
	};

	this.isObject = function(obj) {
		return (
				(Object.prototype.toString.call( obj ) === '[object Object]') &&
				(!(obj instanceof JKobject) || !obj.isArray() )
		);
	};

	var entityMap = {
		"&": "&amp;",
		"<": "&lt;",
		">": "&gt;",
		'"': '&quot;',
//		"'": '&#39;',
//		"/": '&#x2F;'
	};

	this.escapeHtml = function(string) {
		return String(string).replace(/[&<>"]/g, function (s) {
			return entityMap[s];
		});
	};

	this.escapeDelimiter = function(string) {
		var emap = {
			"|": "\\|",
			"(": "\\(",
			")": "\\)",
			".": "\\.",
			"+": "\\+",
			"*": "\\*",
			"?": "\\?",
			"/": "\\/",
			"[": "\\[",
			"]": "\\]",
		};
		return String(string).replace(/[|().+*?/\[\]]/g, function (s) {
			return emap[s];
		});
	};

	function escapeJSstr( s ) {
		s = s.replace(/\\/g, '\\\\');
		s = s.replace(/"/g, '\\"');
		s = s.replace(/\n/g, '\\n');
		s = s.replace(/\r/g, '\\r');
		s = s.replace(/\t/g, '\\t');
		return s;
	}

	/**
	 * returns true for zero values 0, '', null, undefined
	 * AND for empty arrays
	 *
	 * @returns {Boolean}
	 */
	this.isEmpty = function( val ) {
		if (this.isArray(val)) {
			return (val.length === 0);
		}
		return !(val);
	};

	var uniqueId = 0;
	this.getUniqueId = function() {
		return ++uniqueId;
	};

	/**
	 * creates a template
	 *
	 * @param {String}	s			raw template or JK.Template object
	 * @param {JKobject}	data		referenced data
	 * @param {Object}	partials	optional additional Moustache-partials
	 * @returns {jQueryObject}
	 */
	this.template = function( s , data, partials ) {

		var tmpl;

		if ( typeof s == 'string' ) {
			tmpl = new this.Template();
			tmpl.partials = partials;
			tmpl.parse(s);
			if (tmpl.compile) {
				tmpl.compile();
			}
		} else if ( s instanceof this.Template ) {
			tmpl = s;
		}

		return tmpl.render(data);

	};

	/**
	 * remove template
	 *
	 * @param {jQueryObject}	$tag
	 */
	this.removeTemplate = function( $tag, removeTag ) {

		function removeNodeCb( node ) {

			if (node.ddt) {

				while (node.ddt.modelCallbacks.length) {
					var cb = node.ddt.modelCallbacks.shift();
					cb.data.off(cb.cb);
					cb.data = null;
				}
				node.ddt.modelCallbacks = null;
				node.ddt = null;

			}

			if (node.hiddenTemplates) {
				while (node.hiddenTemplates.length) {
					var contents = node.hiddenTemplates.shift();
					while (contents.length) {
						var content = contents.shift();
						JK.removeTemplate( content , false );
					}
				}
				node.hiddenTemplates = null;
			}

			// recursion
			for( var i = 0, len = node.childNodes.length; i < len; i++ ) {
				removeNodeCb( node.childNodes[i] );
			}

		}

		if ($tag && $tag.length && $tag.get(0).ddt) {
			for( var i = 0, len = $tag.length; i < len; i++) {
				removeNodeCb( $tag.get(i) );
			}

			if (removeTag !== false) {
				$tag.remove();
			}
		}

	};

	this.templateToString = function( $tmpl ) {

		var $wrap = $('<div />').append( $tmpl );
		var s = $wrap.html();

	};

	/**
	 * create function, that create nodes natively and contains replacement calls
	 */
	this.setTemplateCompiler1 = function() {

		// nasty IE won't work
		if (JK.needIeStyleFix) return;

		// setTemplateCompiler1
		this.Template.prototype.isCompiled = function() {
			return !!this.renderFn;
		};

		// setTemplateCompiler1
		this.Template.prototype.compileAttribute = function( node, attribute, dls, dle ) {
			var sectionNr;

			// test for single variable in attribute value
			var re = new RegExp( '^' + dls + '[\\s]*(.+?)[\\s]*' + dle + '$' );

			if (attribute.nodeName.match(/^\|\|(\d+)\|\|$/)) {
				// section around attributes

				sectionNr = parseInt( attribute.nodeName.replace(/^\|\|(\d+)\|\|$/, '$1') );
				//this.renderSectionAroundAttributes( node, section, dls, dle );
				this.renderFnCode += 'ri.renderSectionAroundAttributes(n, ri.template.sections[' + sectionNr + ']);\n';

			} else {

				var name = (attribute.name == 'style-ie') ? 'style' : attribute.name;

				// create new attribute
				this.renderFnCode += 'a=document.createAttribute("' + name + '");\n';
				this.renderFnCode += 'n.setAttributeNode(a);\n';

				var matchVar = attribute.nodeValue.match( re );
				var	matchSec = attribute.nodeValue.match( /^\|\|(\d+)\|\|$/ );
				if ( matchVar ) {

					// single variable in attribute value
					var path = matchVar[1];
					if ( JK.isSpecialAttribute( node, attribute )) {
						this.renderFnCode += 'ri.renderSpecialAttrVariable(n, a, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
					} else {
						this.renderFnCode += 'ri.renderAttrVariable(n, a, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
					}

				} else if ( matchSec ) {

					// single section in attribute value
					sectionNr = parseInt( matchSec[1] );
					this.renderFnCode += 'ri.renderAttributeSection(n, a, ri.template.sections[' + sectionNr + ']);\n';

				} else {

					// standard attribute value
					this.renderFnCode += 'a.value="' + attribute.value + '";\n';

				}
			}

		};

		// setTemplateCompiler1
		this.Template.prototype.compileNodes = function(nodes, dls, dle) {

			function setupRegExp(dls, dle) {
				return new RegExp( dls + '([{=&]?)[\\s]*(.+?)[\\s]*' + dle + '[}]?' );
			}

			var re = setupRegExp(dls, dle);

			this.renderFnCode += '(function(p) {\n';
			this.renderFnCode += 'var n,a,t;\n';

			for (var i = 0, len = nodes.length; i < len; ++i) {
				var node = nodes[i];

				if (node.nodeType == 1) {
					// ELEMENT_NODE
					var partialName = '',
						indent = '';

					this.renderFnCode += 'n=document.createElement("' + node.nodeName + '");\n';

					// loop through all attributes
					for (var a = 0, aLen = node.attributes.length; a < aLen; ++a) {
						if ( node.attributes[a].name == 'jks') {
							// section node
							var sectionNr = parseInt( node.attributes[a].value );
							if (this.sections[sectionNr].inverted) {
								this.renderFnCode += 'ri.renderInvertedSection(n,ri.template.sections["' + sectionNr +'"]);\n';
							} else {
								this.renderFnCode += 'ri.renderSection(n,ri.template.sections["' + sectionNr +'"]);\n';
							}
						} else if ( node.attributes[a].name == 'jkp') {
							// partial node
							partialName = node.attributes[a].value;
						} else if ( node.attributes[a].name == 'jkp-indent') {
							// partial indent
							indent = node.attributes[a].value;
						} else {
							this.compileAttribute( node, node.attributes[a], dls, dle);
						}
					}

					this.renderFnCode += 'p.appendChild(n);\n';

					if ( partialName && this.partials[partialName]) {
						this.renderFnCode += 'ri.renderPartial(n,ri.template.partials["' + partialName +'"],"' + indent + '");\n';
					}

					// recursion
					if ( node.childNodes.length && !node.nodeName.match(/^jk[ps]/i) ) {
						this.compileNodes(node.childNodes, dls, dle);
					}

				} else if (node.nodeType == 3) {
					// text node

					// search variables in node text
					var s = node.nodeValue;
					while ( s.length ) {

						var tmplVar = s.match(re);
						if (tmplVar) {
							var match = tmplVar[0];
							var type = tmplVar[1];
							var path = tmplVar[2];
							var position = tmplVar.index;

							// split the node into three parts (before var, var, behind var)
							var part;
							var onlyContent = nodes.length == 1;

							// text before {{}}
							if (position > 0) {
								onlyContent = false;
								part = s.substring( 0, position );
								s = s.substring( position );
								this.renderFnCode += 't=document.createTextNode("' + escapeJSstr(part) + '");\n';
								this.renderFnCode += 'p.appendChild(t);\n';
							}

							// add {{}}
							part = s.substring( 0, match.length );
							s = s.substring( match.length );
							if (type == '=') {
								// delimiter change
								var reDelimiters = new RegExp( '=[\\s]*([\\S]+)[\\s]+([\\S]+)[\\s]*=' );
								var deMatch = match.match(reDelimiters);
								if ( deMatch ) {
									dls = JK.escapeDelimiter(deMatch[1]);
									dle = JK.escapeDelimiter(deMatch[2]);
									re = setupRegExp(dls, dle);
								}
							} else {
								// mustache variable handling
								var escape = (type != '&') && (type != '{');
								onlyContent &= !s.length;

								if (!escape) {
									if (onlyContent) {
										// render unescaped variable content to parent
										this.renderFnCode += 'ri.renderNodeVariable(p, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
									} else {
										// create new DOM node as parent of unescaped variable content
										this.renderFnCode += 'n=document.createElement("JKT");\n';
										this.renderFnCode += 'p.appendChild(n);\n';
										this.renderFnCode += 'ri.renderNodeVariable(n, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
									}
								} else {
									// create new text node to render variable
									this.renderFnCode += 't=document.createTextNode("' + escapeJSstr(part) + '");\n';
									this.renderFnCode += 'ri.renderTextVariable(t, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
									this.renderFnCode += 'p.appendChild(t);\n';
								}

							}

						} else {

							// create new text node
							this.renderFnCode += 't=document.createTextNode("' + escapeJSstr(s) + '");\n';
							this.renderFnCode += 'p.appendChild(t);\n';
							s = '';

						}

					} // while (s.length)

				} // text node

			} // nodes

			this.renderFnCode += '})(n);\n';

		};

		// setTemplateCompiler1
		this.Template.prototype.compile = function() {

			// delimiters
			var dls = this.dls || '{{';
			var dle = this.dle || '}}';

			var $tmpl = $('<div/>').append( $.parseHTML(this.html) );

			if ( $tmpl.contents().length === 0 ) return;

			this.renderFnCode  = 'var ri=this;\n';
			this.renderFnCode += 'var n=document.createElement("DIV");\n';

			// replace variables and sections in attributes
			this.compileNodes( $tmpl.get(0).childNodes, dls, dle );

			this.renderFnCode += 'n.childNodes[0].ddt = this;\n';
			this.renderFnCode += 'return $(n.childNodes);\n';

			/*jslint evil: true */
			this.renderFn = new Function(this.renderFnCode);

			// compile all sections
			for (var i = 0, len = this.sections.length; i < len; i++ ) {
				this.sections[i].tmpl.compile();
			}

		};

	}; // setTemplateCompiler1

	/**
	 * create compiled node tree for cloneNode
	 * with replacement index tree
	 */
	this.setTemplateCompiler2 = function() {

		// nasty IE won't work
		if (JK.needIeStyleFix) return;

		// setTemplateCompiler2
		this.Template.prototype.isCompiled = function() {
			return !!this.cNode;
		};

		// setTemplateCompiler2
		this.Template.prototype.compileAttribute = function( node, cTree, attribute, attrNr, dls, dle ) {
			var sectionNr;

			// test for single variable in attribute value
			var re = new RegExp( '^' + dls + '[\\s]*(.+?)[\\s]*' + dle + '$' );

			if (attribute.nodeName.match(/^\|\|(\d+)\|\|$/)) {
				// section around attributes

				sectionNr = parseInt( attribute.nodeName.replace(/^\|\|(\d+)\|\|$/, '$1') );
				if (!cTree.attrInSection) cTree.attrInSection = [];
				cTree.attrInSection.push(this.sections[sectionNr]);
				cTree.replacements = true;

			} else {

				var name = (attribute.name == 'style-ie') ? 'style' : attribute.name;

				// create new attribute
				var a = document.createAttribute( name );
				node.setAttributeNode( a );

				var matchVar = attribute.nodeValue.match( re );
				var	matchSec = attribute.nodeValue.match( /^\|\|(\d+)\|\|$/ );
				if ( matchVar ) {

					// single variable in attribute value
					var path = matchVar[1];
					if ( JK.isSpecialAttribute( node, attribute )) {
						if (!cTree.specAttrVar) cTree.specAttrVar = [];
						cTree.specAttrVar.push({
							nr: attrNr,
							path: path
						});
					} else {
						if (!cTree.attrVar) cTree.attrVar = [];
						cTree.attrVar.push({
							nr: attrNr,
							path: path
						});
					}
					cTree.replacements = true;

				} else if ( matchSec ) {

					// single section in attribute value
					sectionNr = parseInt( matchSec[1] );
					if (!cTree.attrSection) cTree.attrSection = [];
					cTree.attrSection.push({
						nr: attrNr,
						section: this.sections[sectionNr],
					});
					cTree.replacements = true;

				} else {

					// standard attribute value
					a.value = attribute.value;

				}

				attrNr++;
			}

			return attrNr;

		};

		// setTemplateCompiler2
		this.Template.prototype.compileNodes = function(cNode, cTree, nodes, dls, dle) {

			function setupRegExp(dls, dle) {
				return new RegExp( dls + '([{=&]?)[\\s]*(.+?)[\\s]*' + dle + '[}]?' );
			}

			var re = setupRegExp(dls, dle);

			var cNodeNr = 0,
				nTree;
			for (var i = 0, len = nodes.length; i < len; ++i) {
				var node = nodes[i];

				if (node.nodeType == 1) {
					// ELEMENT_NODE
					var partialName = '',
						indent = '',
						sectionNr = -1;

					var n = document.createElement(node.nodeName);
					nTree = {
							replacements: false,
							children: []
					};

					// loop through all attributes
					var attrNr = 0;
					for (var a = 0, aLen = node.attributes.length; a < aLen; ++a) {
						if ( node.attributes[a].name == 'jks') {
							// section node
							sectionNr = parseInt( node.attributes[a].value );
						} else if ( node.attributes[a].name == 'jkp') {
							// partial node
							partialName = node.attributes[a].value;
						} else if ( node.attributes[a].name == 'jkp-indent') {
							// partial indent
							indent = node.attributes[a].value;
						} else {
							attrNr = this.compileAttribute( n, nTree, node.attributes[a], attrNr, dls, dle);
						}
					}

					cNode.appendChild(n);

					if (sectionNr >= 0) {

						// section
						nTree.section = this.sections[sectionNr];
						nTree.replacements = true;

					} else if ( partialName && this.partials[partialName]) {

						// partial
						nTree.partial = {
							partial: this.partials[partialName],
							indent: indent
						};
						nTree.replacements = true;

					} else if ( node.childNodes.length ) {

						// recursion
						this.compileNodes(n, nTree, node.childNodes, dls, dle);

					}

					if ( nTree.replacements ) {
						cTree.children.push( {
							nr: cNodeNr,
							tree: nTree,
						});
						cTree.replacements = true;
					}
					cNodeNr++;

				} else if (node.nodeType == 3) {
					// text node

					// search variables in node text
					var s = node.nodeValue;
					while ( s.length ) {

						var tmplVar = s.match(re);
						if (tmplVar) {
							var match = tmplVar[0];
							var type = tmplVar[1];
							var path = tmplVar[2];
							var position = tmplVar.index;

							// split the node into three parts (before var, var, behind var)
							var part;
							var onlyContent = nodes.length == 1;

							// text before {{}}
							if (position > 0) {
								onlyContent = false;
								part = s.substring( 0, position );
								s = s.substring( position );
								cNode.appendChild(document.createTextNode(part));
								cNodeNr++;
							}

							// add {{}}
							part = s.substring( 0, match.length );
							s = s.substring( match.length );
							if (type == '=') {
								// delimiter change
								var reDelimiters = new RegExp( '=[\\s]*([\\S]+)[\\s]+([\\S]+)[\\s]*=' );
								var deMatch = match.match(reDelimiters);
								if ( deMatch ) {
									dls = JK.escapeDelimiter(deMatch[1]);
									dle = JK.escapeDelimiter(deMatch[2]);
									re = setupRegExp(dls, dle);
								}
							} else {
								// mustache variable handling
								cTree.replacements = true;
								var escape = (type != '&') && (type != '{');
								onlyContent &= !s.length;

								var tn;
								if (!escape) {
									if (onlyContent) {
										// render unescaped variable content to parent
										cNode.appendChild(document.createTextNode(''));
										cTree.nodeVar = path.replace(/^\.$/, '*');
										cNodeNr++;
									} else {
										// create new DOM node as parent of unescaped variable content
										cNode.appendChild( document.createElement("JKT") );
										nTree = {
												replacements: true,
												children: [],
												nodeVar: path.replace(/^\.$/, '*')
										};
										cTree.children.push( {
											nr: cNodeNr,
											tree: nTree,
										});
										cNodeNr++;
									}
								} else {
									// create new text node to render variable
									cNode.appendChild(document.createTextNode(''));
									if (!cTree.childTextVar) cTree.childTextVar = [];
									cTree.childTextVar.push({
										nr: cNodeNr,
										path: path.replace(/^\.$/, '*')
									});
									cNodeNr++;
								}

							}

						} else {

							// create new text node
							cNode.appendChild(document.createTextNode(s));
							cNodeNr++;
							break;

						}

					} // while (s.length)

				} // text node

			} // nodes

		};

		// setTemplateCompiler2
		this.Template.prototype.compile = function() {

			// delimiters
			var dls = this.dls || '{{';
			var dle = this.dle || '}}';

			var $tmpl = $('<div/>').append( $.parseHTML(this.html) );

			if ( $tmpl.contents().length === 0 ) return;

			this.cNode = document.createElement("DIV");
			this.cTree = {
					replacements: false,
					children: []
			};

			this.compileNodes(this.cNode, this.cTree, $tmpl.get(0).childNodes, dls, dle);


			// compile all sections
			for (var i = 0, len = this.sections.length; i < len; i++ ) {
				this.sections[i].tmpl.compile();
			}

		};

		// setTemplateCompiler2
		this.RenderInstance.prototype.renderTree = function( node, cTree) {

			var i, len, data, attr;

			if (cTree.nodeVar) {
				this.renderNodeVariable(node, cTree.nodeVar);
			} else if (cTree.section) {
				if (cTree.section.inverted) {
					this.renderInvertedSection( node, cTree.section);
				} else {
					this.renderSection( node, cTree.section);
				}
			} else if (cTree.partial) {
				this.renderPartial( node, cTree.partial.partial, cTree.partial.indent);
			} else if (cTree.childTextVar) {
				for( i = 0, len = cTree.childTextVar.length; i < len; i++ ) {
					data = cTree.childTextVar[i];
					this.renderTextVariable(node.childNodes[data.nr], data.path);
				}
			}

			if (cTree.attrVar) {
				for( i = 0, len = cTree.attrVar.length; i < len; i++ ) {
					data = cTree.attrVar[i];
					attr = node.attributes[data.nr];
					this.renderAttrVariable(node, attr, data.path);
				}
			}

			if (cTree.specAttrVar) {
				for( i = 0, len = cTree.specAttrVar.length; i < len; i++ ) {
					data = cTree.specAttrVar[i];
					attr = node.attributes[data.nr];
					this.renderSpecialAttrVariable(node, attr, data.path);
				}
			}

			if (cTree.attrSection) {
				for( i = 0, len = cTree.attrSection.length; i < len; i++ ) {
					data = cTree.attrSection[i];
					attr = node.attributes[data.nr];
					this.renderAttributeSection(node, attr, data.section );
				}
			}

			if (cTree.attrInSection) {
				for( i = 0, len = cTree.attrInSection.length; i < len; i++ ) {
					this.renderSectionAroundAttributes(node, cTree.attrInSection[i] );
				}
			}

			// recursion
			for( i = 0, len = cTree.children.length; i < len; i++ ) {
				data = cTree.children[i];
				this.renderTree(node.childNodes[data.nr], data.tree);
			}

		};

	}; // setTemplateCompiler2

	/**
	 * create compiled node tree for cloneNode
	 * with replacement function tree
	 */
	this.setTemplateCompiler3 = function() {

		// nasty IE won't work
		if (JK.needIeStyleFix) return;

		// setTemplateCompiler3
		this.Template.prototype.isCompiled = function() {
			return !!this.cNode;
		};

		// setTemplateCompiler3
		this.Template.prototype.compileAttribute = function( node, cTree, attribute, attrNr, dls, dle ) {
			var sectionNr;

			// test for single variable in attribute value
			var re = new RegExp( '^' + dls + '[\\s]*(.+?)[\\s]*' + dle + '$' );

			if (attribute.nodeName.match(/^\|\|(\d+)\|\|$/)) {
				// section around attributes

				sectionNr = parseInt( attribute.nodeName.replace(/^\|\|(\d+)\|\|$/, '$1') );
				cTree.renderFn += 'this.renderSectionAroundAttributes(node, this.template.sections[' + sectionNr + ']);\n';
				cTree.replacements = true;

			} else {

				var name = (attribute.name == 'style-ie') ? 'style' : attribute.name;

				// create new attribute
				var a = document.createAttribute( name );
				node.setAttributeNode( a );

				var matchVar = attribute.nodeValue.match( re );
				var	matchSec = attribute.nodeValue.match( /^\|\|(\d+)\|\|$/ );
				if ( matchVar ) {

					// single variable in attribute value
					var path = matchVar[1];
					cTree.renderFn += 'a=node.attributes[' + attrNr + '];';
					if ( JK.isSpecialAttribute( node, attribute )) {
						cTree.renderFn += 'this.renderSpecialAttrVariable(node, a, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
					} else {
						cTree.renderFn += 'this.renderAttrVariable(node, a, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
					}
					cTree.replacements = true;

				} else if ( matchSec ) {

					// single section in attribute value
					sectionNr = parseInt( matchSec[1] );
					cTree.renderFn += 'a=node.attributes[' + attrNr + '];';
					cTree.renderFn += 'this.renderAttributeSection(node, a, this.template.sections[' + sectionNr + ']);\n';
					cTree.replacements = true;

				} else {

					// standard attribute value
					a.value = attribute.value;

				}

				attrNr++;
			}

			return attrNr;

		};

		// setTemplateCompiler3
		this.Template.prototype.compileNodes = function(cNode, cTree, nodes, dls, dle) {

			function setupRegExp(dls, dle) {
				return new RegExp( dls + '([{=&]?)[\\s]*(.+?)[\\s]*' + dle + '[}]?' );
			}

			var re = setupRegExp(dls, dle);

			var cNodeNr = 0;
			for (var i = 0, len = nodes.length; i < len; ++i) {
				var node = nodes[i];

				if (node.nodeType == 1) {
					// ELEMENT_NODE
					var partialName = '',
						indent = '',
						sectionNr = -1;

					var n = document.createElement(node.nodeName);
					var nTree = {
							replacements: false,
							children: [],
							renderFn: ''
					};

					// loop through all attributes
					var attrNr = 0;
					for (var a = 0, aLen = node.attributes.length; a < aLen; ++a) {
						if ( node.attributes[a].name == 'jks') {
							// section node
							sectionNr = parseInt( node.attributes[a].value );
						} else if ( node.attributes[a].name == 'jkp') {
							// partial node
							partialName = node.attributes[a].value;
						} else if ( node.attributes[a].name == 'jkp-indent') {
							// partial indent
							indent = node.attributes[a].value;
						} else {
							attrNr = this.compileAttribute( n, nTree, node.attributes[a], attrNr, dls, dle);
						}
					}

					cNode.appendChild(n);

					if (sectionNr >= 0) {

						// section (handle before attributes, because of special attribute SELECT[value]
						if (this.sections[sectionNr].inverted) {
							nTree.renderFn = 'this.renderInvertedSection(node, this.template.sections["' + sectionNr +'"]);\n' + nTree.renderFn;
						} else {
							nTree.renderFn = 'this.renderSection(node, this.template.sections["' + sectionNr +'"]);\n' + nTree.renderFn;
						}
						nTree.replacements = true;

					} else if ( partialName && this.partials[partialName]) {

						// partial
						nTree.renderFn += 'this.renderPartial(node, this.template.partials["' + partialName +'"],"' + indent + '");\n';
						nTree.replacements = true;

					} else if ( node.childNodes.length ) {

						// recursion
						this.compileNodes(n, nTree, node.childNodes, dls, dle);

					}

					if ( nTree.replacements ) {

						/*jslint evil: true */
						nTree.renderFn = new Function('node', 'a', nTree.renderFn);

						cTree.children.push( {
							nr: cNodeNr,
							tree: nTree,
						});
						cTree.replacements = true;
					}
					cNodeNr++;

				} else if (node.nodeType == 3) {
					// text node

					// search variables in node text
					var s = node.nodeValue;
					while ( s.length ) {

						var tmplVar = s.match(re);
						if (tmplVar) {
							var match = tmplVar[0];
							var type = tmplVar[1];
							var path = tmplVar[2];
							var position = tmplVar.index;

							// split the node into three parts (before var, var, behind var)
							var part;
							var onlyContent = nodes.length == 1;

							// text before {{}}
							if (position > 0) {
								onlyContent = false;
								part = s.substring( 0, position );
								s = s.substring( position );
								cNode.appendChild(document.createTextNode(part));
								cNodeNr++;
							}

							// add {{}}
							part = s.substring( 0, match.length );
							s = s.substring( match.length );
							if (type == '=') {
								// delimiter change
								var reDelimiters = new RegExp( '=[\\s]*([\\S]+)[\\s]+([\\S]+)[\\s]*=' );
								var deMatch = match.match(reDelimiters);
								if ( deMatch ) {
									dls = JK.escapeDelimiter(deMatch[1]);
									dle = JK.escapeDelimiter(deMatch[2]);
									re = setupRegExp(dls, dle);
								}
							} else {
								// mustache variable handling
								cTree.replacements = true;
								var escape = (type != '&') && (type != '{');
								onlyContent &= !s.length;

								var tn;
								if (!escape) {
									if (onlyContent) {
										// render unescaped variable content to parent
										cNode.appendChild(document.createTextNode(''));
										cTree.renderFn += 'this.renderNodeVariable(node, "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
										cNodeNr++;
									} else {
										// create new DOM node as parent of unescaped variable content
										cNode.appendChild( document.createElement("JKT") );
										cTree.renderFn += 'this.renderNodeVariable(node.childNodes[' + cNodeNr + '], "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
										cNodeNr++;
									}
								} else {
									// create new text node to render variable
									cNode.appendChild(document.createTextNode(''));
									cTree.renderFn += 'this.renderTextVariable(node.childNodes[' + cNodeNr + '], "' + path.replace(/^\.$/, '*') + '", "' + dls + '");\n';
									cNodeNr++;
								}

							}

						} else {

							// create new text node
							cNode.appendChild(document.createTextNode(s));
							cNodeNr++;
							break;

						}

					} // while (s.length)

				} // text node

			} // nodes

		};

		// setTemplateCompiler3
		this.Template.prototype.compile = function() {

			// delimiters
			var dls = this.dls || '{{';
			var dle = this.dle || '}}';

			var $tmpl = $('<div/>').append( $.parseHTML(this.html) );

			if ( $tmpl.contents().length === 0 ) return;

			this.cNode = document.createElement("DIV");
			this.cTree = {
					replacements: false,
					children: [],
					renderFn: ''
			};

			this.compileNodes(this.cNode, this.cTree, $tmpl.get(0).childNodes, dls, dle);

			if (this.cTree.renderFn) {
				/*jslint evil: true */
				this.cTree.renderFn = new Function('node', 'a', this.cTree.renderFn);
			}

			// compile all sections
			for (var i = 0, len = this.sections.length; i < len; i++ ) {
				this.sections[i].tmpl.compile();
			}

		};

		// setTemplateCompiler3
		this.RenderInstance.prototype.renderTree = function( node, cTree) {

			var data,
				children = cTree.children,
				childNodes = node.childNodes;

			if (cTree.renderFn) {
				cTree.renderFn.call(this, node);
			}

			// recursion
			for(var i = 0, len = children.length; i < len; i++ ) {
				data = children[i];
				this.renderTree(childNodes[data.nr], data.tree);
			}

		};

	}; // setTemplateCompiler3

}
JK = new JKnamespace();

/**
 * jQuery Plugin detachTemp/reattach and ddtData
 */
(function($){

	$.fn.detachTemp = function() {
		this.data('dt_placeholder',$('<script />').insertAfter( this ));
		return this.detach();
	};

	$.fn.reattach = function() {
		if(this.data('dt_placeholder')){
			this.insertBefore( this.data('dt_placeholder') );
			this.data('dt_placeholder').remove();
			this.removeData('dt_placeholder');
		}
		else if(window.console && console.error) {
			console.error("Unable to reattach this element because its placeholder is not available.");
		}
		return this;
	};

	$.fn.ddtData = function( cb ) {
		var el = this.get(0);
		if (cb && el) {
			if (el.ddt) {
				cb.call( el.ddt.data );
			} else if (el.previousSibling && el.previousSibling.ddt) {
				cb.call( el.previousSibling.ddt.data );
			}
		}
		return this;
	};

})(jQuery);

/**
 * Function.bind polyfill from
 * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind
 */
if (!Function.prototype.bind) {
	Function.prototype.bind = function(oThis) {
		if (typeof this !== 'function') {
			// closest thing possible to the ECMAScript 5
			// internal IsCallable function
			throw new TypeError('Function.prototype.bind - what is trying to be bound is not callable');
		}

		var aArgs   = Array.prototype.slice.call(arguments, 1),
		fToBind = this,
		fNOP    = function() {},
		fBound  = function() {
			return fToBind.apply((this instanceof fNOP) ? this : oThis,
							aArgs.concat(Array.prototype.slice.call(arguments)));
		};

		if (this.prototype) {
			// native functions don't have a prototype
			fNOP.prototype = this.prototype;
		}
		fBound.prototype = new fNOP();

		return fBound;
	};
}