/**
 * encapsulates json response object of favourites list
 */

var TmaFavourites = (function() {

	function TmaFavourites( favourites ) {

		// call super class constructor
		TmaFavourites._super.constructor.apply(this);

		// empty default
		this.timestamp			= "";
		this.content			= "favourites";
		this.totalgroups		= 0;
		this.groupsize			= 0;
		this.count				= 0;
		this.currentgroup		= "";
		this.currentgroup_hex	= "";
		this.groups				= [];

		// init
		this.init( favourites );

	}
	JK.inherit(TmaFavourites, JKobject);

	TmaFavourites.prototype.extend = function( favourites ) {

		// call inherited extend
		this.constructor._super.extend.call(this, favourites, [ 'groups' ]);

		// convert groups and add them
		if (favourites.groups) {
			for (var i = 0, len = favourites.groups.length; i < len; i++) {

				var favGroup = new TmaFavouritesGroup( favourites.groups[i] );
				this.groups.push( favGroup );

			}
		}

	};

	/**
	 * get current group name (non-UTF Toppy safe)
	 *
	 * @returns {String}
	 */
	TmaFavourites.prototype.getCurrentGroupName = function() {

		return (tma.config.utftoppy || !this.currentgroup_hex) ?
				this.currentgroup || ''
				: tma.decodeHexname(this.currentgroup_hex);

	};

	/**
	 * loops through all groups
	 *
	 * @param {Function}	callback	callback function will be called for each group with parameters (nr, group)
	 */
	TmaFavourites.prototype.eachGroup = function( callback ) {

		for (var i = 0, len = this.groups.length; i < len; i++ ) {
			if (callback.apply( this.groups[i], [i, this.groups[i]]) === false) {
				break;
			}
		}
	};

	/**
	 * @param {String} name
	 * @returns {TmaFavouritesGroup}
	 */
	TmaFavourites.prototype.getGroup = function( name ) {

		for (var i = 0, len = this.groups.length; i < len; i++) {
			if (this.groups[i].name == name) {
				return this.groups[i];
			}
		}

		return false;

	};

	return TmaFavourites;

})();
