/**
 * encapsulates favourite-group object
 */

var TmaFavouritesGroup = (function() {

	function TmaFavouritesGroup( group ) {

		// call super class constructor
		TmaFavouritesGroup._super.constructor.apply(this);

		// empty default
		this.count		= 0;
		this.name		= "";
		this.name_hex	= "";
		this.channels	= [];

		// init
		this.init( group );

	}
	JK.inherit(TmaFavouritesGroup, JKobject);

	TmaFavouritesGroup.prototype.extend = function( group ) {

		// call inherited extend, but exclude 'services'
		this.constructor._super.extend.call(this, group, [ 'services' ]);

		// apply channel list
		if (group.services) {
			for (var i = 0, len = group.services.length; i < len; i++) {

				var channel = tma.channels.channel( group.services[i].logoid );
				if (channel) {
					this.channels.push( channel );
				}

			}
		}

	};

	/**
	 * get group name (non-UTF Toppy safe)
	 *
	 * @returns {String}
	 */
	TmaFavouritesGroup.prototype.getName = function() {

		return (tma.config.utftoppy || !this.name_hex) ?
				this.name || ''
				: tma.decodeHexname(this.name_hex);

	};

	return TmaFavouritesGroup;

})();
