var TmaStatusDrive = (function() {

	function TmaStatusDrive(drive) {

		// call super class constructor
		TmaStatusDrive._super.constructor.apply(this);

		// empty default
		this.name			= "";
		this.path			= "";
		this.mountpath		= "";
		this.partitiontype	= 0;
		this.free_mb		= 0;
		this.size_mb		= 0;

		/**
		 * is directory of tma.files on this drive
		 */
		this.isCurrentFilelist	= false;

		// init
		this.init(drive);

		var self = this;
		setImmediate(function() {
			tma.files.on('change', 'directory', function(e, val) {
				self.isCurrentFilelist = (self.mountpath.indexOf( val ) === 0);
			});
		});

	}

	JK.inherit(TmaStatusDrive, JKobject);

	TmaStatusDrive.mixin({

		/**
		 * returns the diskspace in GB
		 */
		sizeGB: function() {
			"watch: {{size_mb}}";
			return this.size_mb >> 10;
		},

		/**
		 * returns the free diskspace in GB
		 */
		freeGB: function() {
			"watch: {{free_mb}}";
			return this.free_mb >> 10;
		},

		/**
		 * returns the used diskspace in GB
		 */
		usedGB: function() {
			"watch: {{free_mb}}";
			return (this.size_mb - this.free_mb) >> 10;
		},

		/**
		 * returns the free diskspace in percent
		 */
		freePercent: function() {
			"watch: {{free_mb}}";
			if (!this.size_mb) return 0;
			return parseInt(this.free_mb * 1000 / this.size_mb) / 10;
		},

		/**
		 * returns the used diskspace in percent
		 */
		usedPercent: function() {
			"watch: {{free_mb}}";
			if (!this.size_mb) return 0;
			return parseInt((this.size_mb - this.free_mb) * 1000 / this.size_mb) / 10;
		},

	});

	return TmaStatusDrive;

})();
